/*							*
 * KTBBS FileBoard ==> STBBS FileBoard converter Ver0.2 *
 *				  Programmed by Jyotaro *
 *							*
 * This program is free on non commercial use only.	*/

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <string>
#include <stl.h>

#include "stbbs.h"

/* KTBBS original
filerec = record
	title	: name;		14	(*ե̾			*)
	submit	: integer;	2  	(*Ͽ			*)
	datetm	: StrDateTime;	17	(*Ͽ(YY/MM/DD HH:MM:SS)	*)
	size	: longint;	4	(*bytes뤫	6.2009	*)
	accesses: integer;	2	(*ɲ		*)
	ASCII	: boolean;	1	(*ƥȤǥɲǽ	*)
	section : byte;		1	(*ܡֹ(̤ѤȤ)	*)
	public	: boolean;	1	(*뤫privateˤ뤫	*)
	comment : string[36];	36	(*			*)
end;
*/

typedef struct tagKTFILEPROPERTY {
	short	size1;
	char	title[14 - 2];
	short	submit;
	short	size2;
	char	datetm[17 - 2];
	int	size;
	short	accesses;
	char	ASCII;
	char	section;
	char	pub;
	short	size3;
	char	comment[36 - 2];
} KTFILEPROPERTY;

void create_fboard(char* file)
{
	KTFILEPROPERTY info;
	char fname[32];
	int num = 1;

	FILE* fp = fopen(file, "rb");
	if (!fp) return;
	while(1) {
		memset(&info, '\0', sizeof(info));
		if (fread(&info, sizeof(info), 1, fp) < 1) break;
		info.title[info.size1 + 1] = '\0';
		info.datetm[info.size2 + 1] = '\0';
		info.comment[info.size3 + 1] = '\0';
//		strcpy(info.title, sjistoeuc(info.title));
//		strcpy(info.datetm, sjistoeuc(info.datetm));
//		strcpy(info.comment, sjistoeuc(info.comment));

		if (info.title[0] != '!') {
			sprintf(fname, "mess%d", num++);
			FILE* st_fp = fopen(fname, "w");
			fprintf(st_fp, "SYSOP\n");
			fprintf(st_fp, "%s\n", info.comment);
			fprintf(st_fp, "%s\n\n", info.title);
			fclose(st_fp);
		}
	}
	fclose(fp);
}

int main(int argc, char* argv[])
{
	if (argc < 2) {
		puts("\nKTBBS FileBoard ==> STBBS FileBoard converter Ver0.2");
		puts("                               Programmed by Jyotaro\n");
		puts("Usage : fconv [FILE]\n");
	}
	create_fboard(argv[1]);
}
