#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/termios.h>
#include <sys/socket.h>
#include <string>
#include <stl.h>		// ANSI Standard Template Library

#include "stbbs.h"
#include "config.h"

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#define MSGSZ 128

typedef struct tagMSGBUF {
	long mtype;
	char mtext[MSGSZ];
} MSGBUF;

void PrintAll(CHINFO* channel)
{
	puts("<TABLE border bgcolor=#ddefaa width=100%>");
	puts("<TR><TD>ͥ</TD><TD>桼ID</TD><TD>ϥɥ</TD><TD>ư</TD><TD></TD></TR>");
	for (int i = 0; i < MAX_CHANNEL; i++) {
		if (channel[i].id[0]) {
			printf("<TR><TD>CH%d:</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD></TR>\n", 
				i, channel[i].id, 
				channel[i].handle, channel[i].what, channel[i].memo);
		} 
	}
	puts("</TABLE>");
}

int main()
{
	int shmid = shmget(PORT, sizeof(CHINFO) * MAX_CHANNEL, 0666);
	if (shmid < 0) { perror("Monitor:shmget"); exit(1); }
	CHINFO* channel = (CHINFO*)shmat(shmid, NULL, 0);
	if ((int)channel < 0) { perror("Monitor:shmat"); exit(1); }
	PrintAll(channel);
	shmdt((char*)channel);
	return 0;
}

