// urldecode.cpp
#include <ctype.h>
#include <string>
#include <stl.h>

#include "jcode.h"
#include "urldecode.h"

char urlchar(const char*& pt)
{
	char c, h;
	int x, n, i;
	switch(*pt) {
	case '%':
		pt++;
		h = toupper(*pt++);
		n = 16 * ((h >= 'A')? (h - 'A' + 10) : (h - '0'));
		h = toupper(*pt++);
		n += ((h >= 'A')? (h - 'A' + 10) : (h - '0')); 
		c = (char)n;
		break;
	case '+':
		c = ' ';
		pt++;
		break;
	case '=':
		c = -1;
		pt++;
		break;
	case '&':
		pt++;
	case '\0':
		c = '\0';
		break;
	default:
		c = *pt++;
		break;
	}
	return c;
}

void urldecode(hash& h, int kcode)
{
	char* pt = getenv("QUERY_STRING");
//	char* pt = "p=%22%A4%C8%A4%E2%A4%A2%A4%C4+%A4%B7%A4%DE%A4%C0%22";
	if (!pt) return;
	while (*pt) {
		string key, value;
		char c;
		while ((c = urlchar(pt)) != -1) {
			if (c == '\0') {
				value = "1";
				goto onlykey;
			}
			key += c;
		}
		while ((c = urlchar(pt)) != '\0') value += c;
		
		kanjiconvert(value.c_str(), kcode);

		onlykey:;
		h[key.c_str()] = value;
	}
}

/*
int main()
{
	hash h;
	urldecode(h);
	return 0;
}
*/
